diff --git a/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
index e914ac39c..578a9d2e9 100644
--- a/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
+++ b/src/main/java/net/minecraft/server/net/command/ConsoleCommandSource.java
@@ -4,6 +4,7 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 import net.minecraft.core.util.phys.Vec3;
@@ -16,6 +17,7 @@ import org.slf4j.Logger;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.List;
+import java.util.function.Supplier;
 
 public class ConsoleCommandSource implements CommandSource, IServerCommandSource {
     private static final Logger LOGGER = LogUtils.getLogger();
@@ -85,6 +87,11 @@ public class ConsoleCommandSource implements CommandSource, IServerCommandSource
         this.getServer().playerList.sendPacketToAllPlayers(new ChatPacket(message));
     }
 
+    @Override
+    public void sendPacketToAllPlayers(Supplier<Packet> packetSupplier) {
+        this.getServer().playerList.sendPacketToAllPlayers(packetSupplier.get());
+    }
+
     @Override
     public World getWorld() {
         return this.server.getDimensionWorld(0);
diff --git a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index 256483608..901049ae8 100644
--- a/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -3,6 +3,7 @@ package net.minecraft.server.net.command;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.packet.ChatPacket;
+import net.minecraft.core.net.packet.Packet;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.Vec3;
@@ -14,6 +15,7 @@ import org.jetbrains.annotations.NotNull;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.List;
+import java.util.function.Supplier;
 
 public class ServerCommandSource implements CommandSource, IServerCommandSource {
     public final MinecraftServer server;
@@ -86,6 +88,11 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
         this.getServer().playerList.sendPacketToAllPlayers(new ChatPacket(message));
     }
 
+    @Override
+    public void sendPacketToAllPlayers(Supplier<Packet> packetSupplier) {
+        this.getServer().playerList.sendPacketToAllPlayers(packetSupplier.get());
+    }
+
     @Override
     public World getWorld() {
         return this.player == null ? this.server.getDimensionWorld(0) : this.player.world;
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java b/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
index a34ac08b1..bb32380bf 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandBan.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.util.helper.UUIDHelper;
@@ -14,11 +15,11 @@ import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.IServerCommandSource;
 
-public class CommandBan {
+public class CommandBan implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.ban.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
         (
             LiteralArgumentBuilder.<CommandSource>literal("ban")
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandColor.java b/src/main/java/net/minecraft/server/net/command/commands/CommandColor.java
index 7b1c5c093..c90675bb9 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandColor.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandColor.java
@@ -8,6 +8,7 @@ import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.entity.player.PlayerServer;
@@ -19,8 +20,8 @@ import net.minecraft.core.net.command.util.CommandHelper;
 
 import java.util.List;
 
-public class CommandColor {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandColor implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("color")
             .then(LiteralArgumentBuilder.<CommandSource>literal("get")
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandDeop.java b/src/main/java/net/minecraft/server/net/command/commands/CommandDeop.java
index 44e96a566..8c2f30377 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandDeop.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandDeop.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.IServerCommandSource;
@@ -18,10 +19,10 @@ import net.minecraft.server.MinecraftServer;
 
 import java.util.List;
 
-public class CommandDeop {
+public class CommandDeop implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.deop.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("deop")
             .requires(CommandSource::hasAdmin)
             .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.players())
@@ -44,7 +45,7 @@ public class CommandDeop {
                             source.sendTranslatableMessage("command.commands.deop.success", player.username);
                             source.sendTranslatableMessage(player, "command.commands.deop.success_receiver");
                         }
-                        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                        server.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
                     }
                     if (!deoppedSomeone) {
                         throw FAILURE.create();
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandDifficulty.java b/src/main/java/net/minecraft/server/net/command/commands/CommandDifficulty.java
index 16a0b2eb9..4d8c4610f 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandDifficulty.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandDifficulty.java
@@ -5,6 +5,7 @@ import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandSource;
@@ -14,8 +15,8 @@ import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import java.util.Arrays;
 import java.util.List;
 
-public class CommandDifficulty {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandDifficulty implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("difficulty")
                 .requires(CommandSource::hasAdmin)
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandEmotes.java b/src/main/java/net/minecraft/server/net/command/commands/CommandEmotes.java
index b1adb5fb2..42c2b9043 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandEmotes.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandEmotes.java
@@ -3,14 +3,15 @@ package net.minecraft.server.net.command.commands;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import net.minecraft.core.net.ChatEmotes;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.net.command.CommandSource;
 
 import java.util.ArrayList;
 import java.util.Map;
 
-public class CommandEmotes {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandEmotes implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("emotes")
             .executes(c -> {
                 CommandSource source = c.getSource();
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandKick.java b/src/main/java/net/minecraft/server/net/command/commands/CommandKick.java
index a0e1cd6bf..ea6b0d048 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandKick.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandKick.java
@@ -6,6 +6,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
@@ -13,11 +14,11 @@ import net.minecraft.core.net.command.helpers.EntitySelector;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.IServerCommandSource;
 
-public class CommandKick {
+public class CommandKick implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.kick.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("kick")
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandList.java b/src/main/java/net/minecraft/server/net/command/commands/CommandList.java
index 324a49007..56e822fbb 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandList.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandList.java
@@ -5,16 +5,17 @@ import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.net.command.IServerCommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 
-public class CommandList {
+public class CommandList implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.list.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("list")
                 .executes(c -> {
                     CommandSource source = c.getSource();
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java b/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
index bec59aa25..3d8e8daa0 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandMe.java
@@ -6,13 +6,14 @@ import com.mojang.brigadier.arguments.BoolArgumentType;
 import com.mojang.brigadier.arguments.StringArgumentType;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.net.command.IServerCommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.packet.ChatPacket;
 
-public class CommandMe {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandMe implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("me")
             .then(RequiredArgumentBuilder.<CommandSource, Boolean>argument("asterisk", BoolArgumentType.bool())
                 .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandNickname.java b/src/main/java/net/minecraft/server/net/command/commands/CommandNickname.java
index f5b45f507..bb529211a 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandNickname.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandNickname.java
@@ -9,6 +9,7 @@ import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.brigadier.tree.CommandNode;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.arguments.ArgumentTypeEntity;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
@@ -18,11 +19,11 @@ import net.minecraft.server.entity.player.PlayerServer;
 
 import java.util.List;
 
-public class CommandNickname {
+public class CommandNickname implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType NICKNAME_TOO_LARGE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.nickname.exception_too_large"));
     private static final SimpleCommandExceptionType NICKNAME_TOO_SMALL = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.nickname.exception_too_small"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("nickname")
             .then(LiteralArgumentBuilder.<CommandSource>literal("set")
                 .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.player())
@@ -40,7 +41,7 @@ public class CommandNickname {
 
                             player.nickname = nickname;
                             player.hadNicknameSet = true;
-                            player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                            player.mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
                             if (source.getSender() == player) {
                                 source.sendTranslatableMessage("command.commands.nickname.set.success", nickname);
                             } else {
@@ -62,7 +63,7 @@ public class CommandNickname {
 
                         player.nickname = nickname;
                         player.hadNicknameSet = true;
-                        player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                        player.mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
 
                         source.sendTranslatableMessage("command.commands.nickname.set.success", nickname);
 
@@ -91,7 +92,7 @@ public class CommandNickname {
 
                         player.nickname = "";
                         player.hadNicknameSet = false;
-                        player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                        player.mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
                         if (source.getSender() == player) {
                             source.sendTranslatableMessage("command.commands.nickname.reset.success");
                         } else {
@@ -109,7 +110,7 @@ public class CommandNickname {
 
                     player.nickname = "";
                     player.hadNicknameSet = false;
-                    player.mcServer.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                    player.mcServer.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
 
                     source.sendTranslatableMessage("command.commands.nickname.reset.success", player.username);
 
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandOp.java b/src/main/java/net/minecraft/server/net/command/commands/CommandOp.java
index b9de58b1e..237f7afe4 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandOp.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandOp.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.IServerCommandSource;
@@ -18,10 +19,10 @@ import net.minecraft.server.MinecraftServer;
 
 import java.util.List;
 
-public class CommandOp {
+public class CommandOp implements CommandManager.CommandRegistry {
     private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.op.exception_failure"));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("op")
             .requires(CommandSource::hasAdmin)
             .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", ArgumentTypeEntity.players())
@@ -44,7 +45,7 @@ public class CommandOp {
                             source.sendTranslatableMessage("command.commands.op.success", player.username);
                             source.sendTranslatableMessage(player, "command.commands.op.success_receiver");
                         }
-                        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+                        server.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
                     }
                     if (!oppedSomeone) {
                         throw FAILURE.create();
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java b/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
index 087044399..720d1d1d4 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandSave.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.world.Dimension;
@@ -14,11 +15,11 @@ import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.net.command.IServerCommandSource;
 import net.minecraft.server.world.WorldServer;
 
-public class CommandSave {
+public class CommandSave implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.save.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("save")
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandScore.java b/src/main/java/net/minecraft/server/net/command/commands/CommandScore.java
index 498479034..ed8daa8d8 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandScore.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandScore.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.IServerCommandSource;
@@ -19,8 +20,8 @@ import net.minecraft.server.MinecraftServer;
 
 import java.util.List;
 
-public class CommandScore {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandScore implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("score")
             .then(LiteralArgumentBuilder.<CommandSource>literal("get")
                 .executes(c -> {
@@ -77,7 +78,7 @@ public class CommandScore {
         if (!(source instanceof IServerCommandSource)) throw CommandExceptions.multiplayerWorldOnly().create();
         MinecraftServer server = ((IServerCommandSource) source).getServer();
         player.score = score;
-        server.playerList.sendPacketToAllPlayers(new UpdatePlayerProfilePacket(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator()));
+        server.playerList.updatePlayerProfile(player.username, player.nickname, player.uuid, player.score, player.chatColor, true, player.isOperator());
         if (player == source.getSender()) {
             source.sendTranslatableMessage("command.commands.score.set.success", score);
         } else {
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandStop.java b/src/main/java/net/minecraft/server/net/command/commands/CommandStop.java
index 2c9eedbe0..79cdd1cc2 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandStop.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandStop.java
@@ -3,14 +3,15 @@ package net.minecraft.server.net.command.commands;
 import com.mojang.brigadier.Command;
 import com.mojang.brigadier.CommandDispatcher;
 import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.world.World;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.server.net.command.IServerCommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 
-public class CommandStop {
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+public class CommandStop implements CommandManager.CommandRegistry {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("stop")
                 .requires(CommandSource::hasAdmin)
                 .executes(c -> {
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandUnban.java b/src/main/java/net/minecraft/server/net/command/commands/CommandUnban.java
index 7af0aa6c0..9b28d8edd 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandUnban.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandUnban.java
@@ -7,17 +7,18 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.MinecraftServer;
 import net.minecraft.server.net.command.IServerCommandSource;
 
-public class CommandUnban {
+public class CommandUnban implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.unban.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("unban")
diff --git a/src/main/java/net/minecraft/server/net/command/commands/CommandWhitelist.java b/src/main/java/net/minecraft/server/net/command/commands/CommandWhitelist.java
index bbaeae680..066175427 100644
--- a/src/main/java/net/minecraft/server/net/command/commands/CommandWhitelist.java
+++ b/src/main/java/net/minecraft/server/net/command/commands/CommandWhitelist.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.builder.LiteralArgumentBuilder;
 import com.mojang.brigadier.builder.RequiredArgumentBuilder;
 import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandManager;
 import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.util.helper.UUIDHelper;
@@ -17,11 +18,11 @@ import net.minecraft.server.net.command.IServerCommandSource;
 import java.util.Set;
 import java.util.UUID;
 
-public class CommandWhitelist {
+public class CommandWhitelist implements CommandManager.CommandRegistry {
     private static final DynamicCommandExceptionType FAILURE =
         new DynamicCommandExceptionType(arg -> () -> I18n.getInstance().translateKeyAndFormat("command.commands.whitelist.exception_failure", arg));
 
-    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+    public void register(CommandDispatcher<CommandSource> dispatcher) {
         dispatcher.register
             (
                 LiteralArgumentBuilder.<CommandSource>literal("whitelist")
